//audio
datablock AudioProfile(superScopeFire)
{
   filename    = "./superScopeFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(superScopeHit)
{
   filename    = "./superScopeHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(superScopeDraw)
{
   filename    = "./superScopeDraw.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ChargedSound)
{
   filename    = "./superScopeCharged.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(ChargedFireSound)
{
   filename    = "./superScopeChargedFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bulletHitSound)
{
   filename    = "./superScopeHit.wav";
   description = AudioClose3d;
   preload = true;
};
//shell
datablock DebrisData(SuperScopeDebris)
{
	shapeFile = "./gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(trailParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bullet.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.9 0.45 0.45";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(trailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "trailParticle";

   uiName = "Super Scope Trail";
};
datablock ParticleData(bigtrailParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bigbullet.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.9 0.45 0.45";
	sizes[0]      = 3;
	sizes[1]      = 3.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(bigtrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "bigtrailParticle";

   uiName = "Super Scope Charged Trail";
};
datablock ParticleData(SuperScopeExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.0 0.4";
	colors[1]     = "0.9 0.9 0.0 0.2";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SuperScopeExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SuperScopeExplosionParticle";

   useEmitterColors = true;
   uiName = "Super Scope Hit Dust";
};


datablock ParticleData(SuperScopeExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.75 0.75 0.0 0.45";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SuperScopeExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SuperScopeExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Super Scope Hit Flash";
};

datablock ExplosionData(SuperScopeExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = SuperScopeExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = SuperScopeExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.3 0.3 0";
   lightEndColor = "0 0 0";
};


AddDamageType("superScope",   '<bitmap:add-ons/Weapon_SuperScope/CI_superScope> %1',    '%2 <bitmap:add-ons/Weapon_SuperScope/CI_superScope> %1',0.2,1);
datablock ProjectileData(SuperScopeProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::superScope;
   radiusDamageType    = $DamageType::superScope;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = SuperScopeExplosion;
   particleEmitter     = "trailEmitter";
   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Super Scope Shot";
};

datablock ProjectileData(SuperScopeChargedProjectile)
{
   projectileShapeName = "./bigbullet.dts";
   directDamage        = 85;
   directDamageType    = $DamageType::superScope;
   radiusDamageType    = $DamageType::superScope;

   brickExplosionRadius = 10;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 35;
   brickExplosionMaxVolume = 5;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 10;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 750;
   verticalImpulse	  = 750;
   explosion           = SuperScopeExplosion;
   particleEmitter     = "bigtrailEmitter";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 7500;
   fadeDelay           = 5000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Super Scope Charged Shot";
};

//////////
// item //
//////////
datablock ItemData(SuperScopeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./superScopeII.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Super Scope (Smash)";
	iconName = "./icon";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = SuperScopeImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SuperScopeImage)
{
   // Basic Item properties
   shapeFile = "./superScopeII.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SuperScopeProjectile;
   projectileType = Projectile;

	casing = SuperScopeShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SuperScope.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.8;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= superScopeDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";
	
	stateName[2]			= "Charge";
	statetransitionOnTimeOut[2]	= "ChargeFull";
	stateTransitiononTriggerup[2]   = "Fire";
	stateWaitForTimeout[2]		= false;
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[2]		= 1.5;
	stateScript[2]              = "OnCharge";
	
	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateSound[3]					= superScopeFireSound;

	stateName[4]					= "ChargeFull";
	stateAllowImageChange[4]        = true;
	stateTransitiononTriggerup[4]   = "ChargeFire";
	StateTransitionOnTimeout[4] 	= "ChargeFull";
	stateTimeoutValue[4]			= 0.05;
	
	stateName[5]                    = "ChargeFire";
	stateTransitionOnTimeout[5]     = "Reload";
	stateTimeoutValue[5]            = 1.4;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onChargeFire";
	stateWaitForTimeout[5]			= true;
	stateSound[5]					= ChargedFireSound;

	stateName[6]			= "Reload";
	stateSequence[6]                = "Reload";
	stateTimeoutValue[6]            = 0.12;
	stateTransitionOntimeout[6]   = "Ready";
	stateSequence[6]	        = "Ready";
};
function SuperScopeImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	Parent::onFire(%this,%obj,%slot);	
}

function SuperScopeImage::onChargeFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
	%obj.playThread(2, shiftAway);

	%projectile = SuperScopeChargedProjectile;
	%spread = 0;
	%shellcount = 1;
	%obj.playAudio(1, ChargedFireSound);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function superScopeImage::onCharge(%this, %obj, %slot)
{
    %obj.playAudio(1, ChargedSound);
}

function superScopeImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
	%obj.playThread(2, plant);

	%projectile = SuperScopeProjectile;
	%spread = 0;
	%shellcount = 1;
	%obj.stopAudio(1);
	%obj.playAudio(1, superScopeFire);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}